// compile with: gcc -g -o r13server -z execstack -fno-stack-protector r13server.c

#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SRVPORT 7777
#define BUFSIZE 1024

void fatal_error(char *s) {
    perror(s);
    exit(1);
}

void rot13(char *buf) {
    int i = 0;
    unsigned char c;
    for (i=0; c = buf[i]; i++)
    	buf[i] =  isalpha(c) ? tolower(c) <'n' ? c+13 : c-13 : c;
}

void sendrot13(int sock, char *str) {
    unsigned char c;
    int i;
    char rot[500];

    printf("incoming string: %s", str);

    strncpy(rot, str, strlen(str)+1); // here is the bug
    rot13(rot);
    
    printf("        sending: %s", rot);
    send(sock, rot, strlen(rot), 0);
}


int main(int argc, char **argv) {
    char buf[BUFSIZE];
    struct sockaddr_in saddr;
    int saddrlen = sizeof(saddr);
    int sock_listen, sock_conn;

    if ( (sock_listen = socket(AF_INET, SOCK_STREAM, 0)) == -1 ) {
        fatal_error("socket");
    }

    memset(&saddr, '0', sizeof(saddr));
    memset(buf, '\0', sizeof(buf));
    saddr.sin_port = htons(SRVPORT);
    saddr.sin_family = AF_INET;
    saddr.sin_addr.s_addr = htonl(INADDR_ANY);

    if (bind(sock_listen, (struct sockaddr *)&saddr, sizeof(saddr)) == -1) {
        fatal_error("bind");
    }

    if (listen(sock_listen, 5) == -1) {
        fatal_error("listen");
    }

    printf("waiting for client connections on port %d...\n", SRVPORT);
    while ((sock_conn = accept(sock_listen, (struct sockaddr *)&saddr, &saddrlen)) != -1) {

        //get request
        int recvdbytes = recv(sock_conn, buf, BUFSIZE-1, 0);
        buf[recvdbytes] = '\0';

        //send rot13(request) (bugged)
        sendrot13(sock_conn, buf);

        //echo request
        send(sock_conn, buf, recvdbytes, 0);
	
        //close connection
        close(sock_conn);

        printf("***\nwaiting for next client...\n");
    }
}
